-- BadKitty's graphical mechanics

function BadKitty_LoadFrames()
	--					1	2		3		4		5		6		7		8		9
	--					SR	Man-C	Rake	Rip		FFF		Combo	TF		Zerk	Energy
	BadKittyCFrames = 	{1	,2		,3		,4		,5		,6		,7		,8		,9}
	
	--					1		2		3		4
	--					Man		Demo	Lac		FFF
	BadKittyBFrames = 	{1		,2		,3		,4}
	BadKittyFrame:SetClampedToScreen(true)
	BadKittyDefaultCFrames = BadKittyCFrames
	BadKittyDefaultBFrames = BadKittyBFrames
	BadKitty_SetFrames()
end

function BadKitty_SetFrames()
	local _G = getfenv()
	BadKittyCatSR = _G["BadKittyFrameBar"..BadKittyCFrames[1]]
	BadKittyCatMangle = _G["BadKittyFrameBar"..BadKittyCFrames[2]]
	BadKittyCatRake = _G["BadKittyFrameBar"..BadKittyCFrames[3]]
	BadKittyCatRip = _G["BadKittyFrameBar"..BadKittyCFrames[4]]
	BadKittyCatFFF = _G["BadKittyFrameBar"..BadKittyCFrames[5]]
	BadKittyCatCP = _G["BadKittyFrameBar"..BadKittyCFrames[6]]
	BadKittyBearMangle = _G["BadKittyBearBar"..BadKittyBFrames[1]]
	BadKittyBearDemo = _G["BadKittyBearBar"..BadKittyBFrames[2]]
	BadKittyBearLac = _G["BadKittyBearBar"..BadKittyBFrames[3]]
	BadKittyBearFFF = _G["BadKittyBearBar"..BadKittyBFrames[4]]
	
	BadKittyCatSRText = _G["BadKittyFrameBar"..BadKittyCFrames[1].."Text"]
	BadKittyCatMangleText = _G["BadKittyFrameBar"..BadKittyCFrames[2].."Text"]
	BadKittyCatRakeText = _G["BadKittyFrameBar"..BadKittyCFrames[3].."Text"]
	BadKittyCatRipText = _G["BadKittyFrameBar"..BadKittyCFrames[4].."Text"]
	BadKittyCatFFFText = _G["BadKittyFrameBar"..BadKittyCFrames[5].."Text"]
	BadKittyCatCPText = _G["BadKittyFrameBar"..BadKittyCFrames[6].."Text"]
	BadKittyBearMangleText = _G["BadKittyBearBar"..BadKittyBFrames[1].."Text"]
	BadKittyBearDemoText = _G["BadKittyBearBar"..BadKittyBFrames[2].."Text"]
	BadKittyBearLacText = _G["BadKittyBearBar"..BadKittyBFrames[3].."Text"]
	BadKittyBearFFFText = _G["BadKittyBearBar"..BadKittyBFrames[4].."Text"]
	
	BadKittyCatSRSecs = _G["BadKittyFrameBar"..BadKittyCFrames[1].."Secs"]
	BadKittyCatMangleSecs = _G["BadKittyFrameBar"..BadKittyCFrames[2].."Secs"]
	BadKittyCatRakeSecs = _G["BadKittyFrameBar"..BadKittyCFrames[3].."Secs"]
	BadKittyCatRipSecs = _G["BadKittyFrameBar"..BadKittyCFrames[4].."Secs"]
	BadKittyCatFFFSecs = _G["BadKittyFrameBar"..BadKittyCFrames[5].."Secs"]
	BadKittyCatCPSecs = _G["BadKittyFrameBar"..BadKittyCFrames[6].."Secs"]
	BadKittyBearMangleSecs = _G["BadKittyBearBar"..BadKittyBFrames[1].."Secs"]
	BadKittyBearDemoSecs = _G["BadKittyBearBar"..BadKittyBFrames[2].."Secs"]
	BadKittyBearLacSecs = _G["BadKittyBearBar"..BadKittyBFrames[3].."Secs"]
	BadKittyBearFFFSecs = _G["BadKittyBearBar"..BadKittyBFrames[4].."Secs"]
end


function BadKitty_HideAll()
	BKOOCFrame:Hide()
	BKBearOOCFrame:Hide()
	BKWMangle:Hide()
	BKWSR:Hide()
	BKWRake:Hide()
	BKWRip:Hide()
	BKWFFF:Hide()
	BKWTF:Hide()
	BKWZerk:Hide()
	BKWOOC:Hide()
	BKWBearMangle:Hide()
	BKWBearZerk:Hide()
	BKWBearLacerate:Hide()
	BKWBearBarkskin:Hide()
	BKWBearDemo:Hide()
	BKWBearFFF:Hide()
	BadKittyWarnings:EnableMouse(0)
	BKWMoveFrame:SetAlpha(0)
	BKWMoveFrame:EnableMouse(0)
	BadKittyBearWarnings:EnableMouse(0)
	BKWBearMoveFrame:SetAlpha(0)
	BKWBearMoveFrame:EnableMouse(0)
	BKWMangle:EnableMouse(0)
	BKWSR:EnableMouse(0)
	BKWRake:EnableMouse(0)
	BKWRip:EnableMouse(0)
	BKWFFF:EnableMouse(0)
	BKWTF:EnableMouse(0)
	BKWZerk:EnableMouse(0)
	BKWOOC:EnableMouse(0)
	BKWBearMangle:EnableMouse(0)
	BKWBearZerk:EnableMouse(0)
	BKWBearLacerate:EnableMouse(0)
	BKWBearDemo:EnableMouse(0)
	BKWBearBarkskin:EnableMouse(0)
	BKWBearFFF:EnableMouse(0)
end

function BadKitty_UpdateMe()
	if not BadKittyUp or not BAD_KITTY_SAVAGE_ROAR then	-- because lua errors on load otherwise
		--player = UnitGUID("player")
		--BadKitty_Setup()
		--BadKitty_Create()	
		return
	end
	if not BadKittyCatSR then
		BadKitty_SetFrames()
	end
	--if BadKittyUp[BADKITTY_SAVAGE_ROAR][UnitGUID("player")]==nil then
	--	BadKittyUp[BADKITTY_SAVAGE_ROAR][UnitGUID("player")]=0
	--end
	local shapeshift = GetShapeshiftForm(true)
	if BadKittySaves[8]==0 then
		BadKittyFrame:SetAlpha(1)
		BadKittyFrame:EnableMouse(1)
		BadKittyBear:SetAlpha(1)
		BadKittyBear:EnableMouse(1)
	elseif BadKittySaves[7]==1 and not InCombatLockdown() then
		BadKittyFrame:SetAlpha(0)
		BKOOCFrame:SetAlpha(0)
		BadKittyFrame:EnableMouse(0)
		BadKittyBear:EnableMouse(0)
		BadKittyBear:SetAlpha(0)
		BKBearOOCFrame:SetAlpha(0)
	elseif InCombatLockdown() or BadKittySaves[7]==0 then
		if BadKittySaves[9]==1 then
			BadKittyFrame:SetAlpha(1)
			BKOOCFrame:SetAlpha(0.5)
			BadKittyFrame:EnableMouse(1)
			BadKittyBear:EnableMouse(1)
			BadKittyBear:SetAlpha(1)
			BKBearOOCFrame:SetAlpha(0.5)
		else
			BadKittyFrame:SetAlpha(0)
			BKOOCFrame:SetAlpha(0)
			BadKittyFrame:EnableMouse(0)
			BadKittyBear:EnableMouse(0)
			BadKittyBear:SetAlpha(0)
			BKBearOOCFrame:SetAlpha(0)
		end
		if shapeshift==3 or shapeshift==0 then
			BadKittyBear:EnableMouse(0)
			BadKittyBear:SetAlpha(0)
			BKBearOOCFrame:SetAlpha(0)
		elseif shapeshift==1 then
			BadKittyFrame:SetAlpha(0)
			BKOOCFrame:SetAlpha(0)
			BadKittyFrame:EnableMouse(0)
		else
			BadKittyBear:EnableMouse(0)
			BadKittyBear:SetAlpha(0)
			BadKittyFrame:SetAlpha(0)
			BKOOCFrame:SetAlpha(0)
			BKBearOOCFrame:SetAlpha(0)
			BadKittyFrame:EnableMouse(0)
		end
	end
	local timeleft = {}
	local timenow=GetTime()
	local target = UnitGUID("target")
	local placeholder = BadKitty_Targets(target)
	if placeholder==0 then target = 0 end
	for i,j in pairs(BadKittySpells) do
		if i==BADKITTY_SAVAGE_ROAR then
			timeleft[i]=BadKittyUp[i][player]-timenow
		else
			if BadKittyUp[i][target]==nil then BadKittyUp[i][target]=0 end
			timeleft[i]=BadKittyUp[i][target]-timenow
		end
		if timeleft[i]<0 then timeleft[i]=0 end
	end
	BadKittyCatSR:SetValue(timeleft[BADKITTY_SAVAGE_ROAR])
	BadKitty_Output(timeleft[BADKITTY_SAVAGE_ROAR])
	BadKitty_UpdateCPs()
	BadKittyCatRip:SetValue(timeleft[BADKITTY_RIP])
	BadKittyCatRake:SetValue(timeleft[BADKITTY_RAKE])
	if BadKittyUp[BADKITTY_FAERIE_FIRE_FERAL][target]==0 then
		BadKittyCatFFF:SetValue(timeleft[BADKITTY_FAERIE_FIRE])
		BadKittyBearFFF:SetValue(timeleft[BADKITTY_FAERIE_FIRE])
	else
		BadKittyCatFFF:SetValue(timeleft[BADKITTY_FAERIE_FIRE_FERAL])
		BadKittyBearFFF:SetValue(timeleft[BADKITTY_FAERIE_FIRE_FERAL])
	end
	if BadKittyUp[BADKITTY_MANGLE_CAT][target]~=0 then
		BadKittyCatMangle:SetValue(timeleft[BADKITTY_MANGLE_CAT])
		BadKittyBearMangle:SetValue(timeleft[BADKITTY_MANGLE_CAT])
	elseif BadKittyUp[BADKITTY_MANGLE_BEAR][target]~=0 then
		BadKittyCatMangle:SetValue(timeleft[BADKITTY_MANGLE_BEAR])
		BadKittyBearMangle:SetValue(timeleft[BADKITTY_MANGLE_BEAR])
	else
		BadKittyCatMangle:SetValue(timeleft[BADKITTY_TRAUMA])
		BadKittyBearMangle:SetValue(timeleft[BADKITTY_TRAUMA])
	end
	if BadKittyUp[BADKITTY_DEMO_ROAR][target]==0 then
		BadKittyBearDemo:SetValue(timeleft[BADKITTY_DEMO_SHOUT])
	else
		BadKittyBearDemo:SetValue(timeleft[BADKITTY_DEMO_ROAR])
	end
	BadKittyBearLac:SetValue(timeleft[BADKITTY_LACERATE])
	if BadKittyUp[BADKITTY_LACERATE][target]~=0 then
		BadKittyBearLacText:SetText("Lacerate x" .. LacCount)
	end
	BadKitty_Seconds(timeleft)
	BadKitty_TFZerk(timenow)
end

function BadKitty_UpdateCPs()
	cps = GetComboPoints(UnitName("player"))
	if cps ==1 then
		BadKittyCatCP:SetStatusBarColor(0,1,0);
	end
	if cps ==2 then
		BadKittyCatCP:SetStatusBarColor(0.25,0.75,0);
	end
	if cps ==3 then
		BadKittyCatCP:SetStatusBarColor(0.5,0.5,0);
	end
	if cps ==4 then
		BadKittyCatCP:SetStatusBarColor(0.75,0.25,0);
	end
	if cps ==5 then
		BadKittyCatCP:SetStatusBarColor(1,0,0);
	end
	BadKittyCatCP:SetValue(cps)
	BadKittyCatCPSecs:SetText(floor(cps))
end 

function BadKitty_OOC(boolean)
	if boolean==1 and BadKittySaves[10]==1 then
		BKOOCFrame:Show()
		BKBearOOCFrame:Show()
	else
		BKOOCFrame:Hide()
		BKBearOOCFrame:Hide()
	end
	if boolean==1 and BadKittySaves[11]==1 and GetShapeshiftForm(true)== 3 and InCombatLockdown() then
		BKWOOC:Show()
	elseif not InCombatLockdown() or GetShapeshiftForm(true)~= 3 then
		BKWOOC:Hide()
	else
		BKWOOC:Hide()
	end
end

function BadKitty_Seconds(timeleft)
	for i,j in pairs(timeleft) do
		timeleft[i] = floor(10*j)/10
	end
	if timeleft[BADKITTY_MANGLE_CAT]~=0 then
		BadKittyCatMangleSecs:SetText(timeleft[BADKITTY_MANGLE_CAT])
		BadKittyBearMangleSecs:SetText(timeleft[BADKITTY_MANGLE_CAT])
	elseif timeleft[BADKITTY_MANGLE_BEAR]~=0 then
		BadKittyCatMangleSecs:SetText(timeleft[BADKITTY_MANGLE_BEAR])
		BadKittyBearMangleSecs:SetText(timeleft[BADKITTY_MANGLE_BEAR])
	else
		BadKittyCatMangleSecs:SetText(timeleft[BADKITTY_TRAUMA])
		BadKittyBearMangleSecs:SetText(timeleft[BADKITTY_TRAUMA])
	end
	BadKittyCatSRSecs:SetText(timeleft[BADKITTY_SAVAGE_ROAR])
	BadKittyCatRakeSecs:SetText(timeleft[BADKITTY_RAKE])
	BadKittyCatRipSecs:SetText(timeleft[BADKITTY_RIP])
	if timeleft[BADKITTY_FAERIE_FIRE]~=0 then
		BadKittyCatFFFSecs:SetText(timeleft[BADKITTY_FAERIE_FIRE])
		BadKittyBearFFFSecs:SetText(timeleft[BADKITTY_FAERIE_FIRE])
	else
		BadKittyCatFFFSecs:SetText(timeleft[BADKITTY_FAERIE_FIRE_FERAL])
		BadKittyBearFFFSecs:SetText(timeleft[BADKITTY_FAERIE_FIRE_FERAL])
	end
	if timeleft[BADKITTY_DEMO_ROAR]~=0 then
		BadKittyBearDemoSecs:SetText(timeleft[BADKITTY_DEMO_ROAR])
	else
		BadKittyBearDemoSecs:SetText(timeleft[BADKITTY_DEMO_SHOUT])
	end
	BadKittyBearLacSecs:SetText(timeleft[BADKITTY_LACERATE])
	if GetShapeshiftForm(true)==3 then	-- Call warnings.  A bit messy.
		BadKitty_Warnings(timeleft)
		BKWBearMangle:Hide()
		BKWBearZerk:Hide()
		BKWBearLacerate:Hide()
		BKWBearDemo:Hide()
		BKWBearBarkskin:Hide()
		BKWBearFFF:Hide()
	elseif GetShapeshiftForm(true)==1 then
		BadKitty_BearWarnings(timeleft)
		BKWMangle:Hide()
		BKWSR:Hide()
		BKWRake:Hide()
		BKWRip:Hide()
		BKWFFF:Hide()
	else
		BKWMangle:Hide()
		BKWSR:Hide()
		BKWRake:Hide()
		BKWRip:Hide()
		BKWFFF:Hide()
		BKWBearMangle:Hide()
		BKWBearZerk:Hide()
		BKWBearLacerate:Hide()
		BKWBearDemo:Hide()
		BKWBearBarkskin:Hide()
		BKWBearFFF:Hide()
	end
end

function BadKitty_Warnings(timeleft)
	if BadKittySaves[11]==0 or not InCombatLockdown() then
		BKWMangle:Hide()
		BKWSR:Hide()
		BKWRake:Hide()
		BKWRip:Hide()
		BKWFFF:Hide()
		return 0
	end
	for i,j in pairs(timeleft) do
		if j < BadKittySaves[12] and j >0 and InCombatLockdown() then
			if i==BADKITTY_MANGLE_CAT or i==BADKITTY_MANGLE_BEAR or i==BADKITTY_TRAUMA then
				if max(timeleft[BADKITTY_MANGLE_CAT],timeleft[BADKITTY_MANGLE_BEAR],timeleft[BADKITTY_TRAUMA])>BadKittySaves[12] 
					or max(timeleft[BADKITTY_MANGLE_CAT],timeleft[BADKITTY_MANGLE_BEAR],timeleft[BADKITTY_TRAUMA])==0 then
				else
					BKWMangle:Show()
					BKWMangle:SetBackdropColor(1,1,1)
					BKWMangleText:SetText(j)
				end
			elseif i==BADKITTY_SAVAGE_ROAR then 
				BKWSR:Show()
				BKWSR:SetBackdropColor(1,1,1)
				BKWSRText:SetText(j)
			elseif i==BADKITTY_RAKE then 
				BKWRake:Show()
				BKWRake:SetBackdropColor(1,1,1)
				BKWRakeText:SetText(j)
			elseif i==BADKITTY_RIP then 
				BKWRip:Show()
				BKWRip:SetBackdropColor(1,1,1)
				BKWRipText:SetText(j)
			elseif i==BADKITTY_FAERIE_FIRE_FERAL or i==BADKITTY_FAERIE_FIRE then 
				if max(timeleft[BADKITTY_FAERIE_FIRE],timeleft[BADKITTY_FAERIE_FIRE_FERAL])>BadKittySaves[12] 
					or max(timeleft[BADKITTY_FAERIE_FIRE],timeleft[BADKITTY_FAERIE_FIRE_FERAL])==0 then
				else 
					BKWFFF:Show()
					BKWFFF:SetBackdropColor(1,1,1)
					BKWFFFText:SetText(j)
				end
			end
		elseif j==0 and InCombatLockdown() then
			if i==BADKITTY_MANGLE_CAT or i==BADKITTY_MANGLE_BEAR or i==BADKITTY_TRAUMA then
				if max(timeleft[BADKITTY_MANGLE_CAT],timeleft[BADKITTY_MANGLE_BEAR],timeleft[BADKITTY_TRAUMA])>0 then 
				else
					BKWMangle:Show()
					BKWMangle:SetBackdropColor(1,0,0)
					BKWMangleText:SetText(j)
				end
			elseif i==BADKITTY_SAVAGE_ROAR then 
				BKWSR:Show()
				BKWSR:SetBackdropColor(1,0,0)
				BKWSRText:SetText(j)
			elseif i==BADKITTY_RAKE then 
				BKWRake:Show()
				BKWRake:SetBackdropColor(1,0,0)
				BKWRakeText:SetText(j)
			elseif i==BADKITTY_RIP then 
				BKWRip:Show()
				BKWRip:SetBackdropColor(1,0,0)
				BKWRipText:SetText(j)
			elseif i==BADKITTY_FAERIE_FIRE_FERAL or i==BADKITTY_FAERIE_FIRE then 
				if max(timeleft[BADKITTY_FAERIE_FIRE_FERAL],timeleft[BADKITTY_FAERIE_FIRE])>0 then 
				else
					BKWFFF:Show()
					BKWFFF:SetBackdropColor(1,0,0)
					BKWFFFText:SetText(j)
				end
			end
		elseif j>BadKittySaves[12] and InCombatLockdown() then
			if i==BADKITTY_MANGLE_CAT or i==BADKITTY_MANGLE_BEAR or i==BADKITTY_TRAUMA then BKWMangle:Hide()
			elseif i==BADKITTY_SAVAGE_ROAR then BKWSR:Hide()
			elseif i==BADKITTY_RAKE then BKWRake:Hide()
			elseif i==BADKITTY_RIP then BKWRip:Hide()
			elseif i==BADKITTY_FAERIE_FIRE_FERAL or i==BADKITTY_FAERIE_FIRE then BKWFFF:Hide()
			end
		end
	end
end

function BadKitty_BearWarnings(timeleft)
	if BadKittySaves[11]==0 or not InCombatLockdown() then
		BKWBearMangle:Hide()
		BKWBearZerk:Hide()
		BKWBearLacerate:Hide()
		BKWBearDemo:Hide()
		BKWBearBarkskin:Hide()
		BKWBearFFF:Hide()
		return 0
	end
	for i,j in pairs(timeleft) do
		if j < BadKittySaves[12] and j >0 and InCombatLockdown() then
			if i==BADKITTY_MANGLE_CAT or i==BADKITTY_MANGLE_BEAR or i==BADKITTY_TRAUMA then
				if max(timeleft[BADKITTY_MANGLE_CAT],timeleft[BADKITTY_MANGLE_BEAR],timeleft[BADKITTY_TRAUMA])>BadKittySaves[12] 
					or max(timeleft[BADKITTY_MANGLE_CAT],timeleft[BADKITTY_MANGLE_BEAR],timeleft[BADKITTY_TRAUMA])==0 then
				else
					BKWBearMangle:Show()
					BKWBearMangle:SetBackdropColor(1,1,1)
					BKWBearMangleText:SetText(j)
				end
			elseif i==BADKITTY_LACERATE then 
				BKWBearLacerate:Show()
				BKWBearLacerate:SetBackdropColor(1,1,1)
				BKWBearLacerateText:SetText(j)
			elseif i==BADKITTY_FAERIE_FIRE_FERAL or i==BADKITTY_FAERIE_FIRE then 
				if max(timeleft[BADKITTY_FAERIE_FIRE],timeleft[BADKITTY_FAERIE_FIRE_FERAL])>BadKittySaves[12] 
					or max(timeleft[BADKITTY_FAERIE_FIRE],timeleft[BADKITTY_FAERIE_FIRE_FERAL])==0 then
				else 
					BKWFFF:Show()
					BKWFFF:SetBackdropColor(1,1,1)
					BKWFFFText:SetText(j)
				end
			elseif i==BADKITTY_DEMO_SHOUT or i==BADKITTY_DEMO_ROAR then 
				if max(timeleft[BADKITTY_DEMO_SHOUT],timeleft[BADKITTY_DEMO_ROAR])>BadKittySaves[12] 
					or max(timeleft[BADKITTY_DEMO_SHOUT],timeleft[BADKITTY_DEMO_ROAR])==0 then
				else 
					BKWBearDemo:Show()
					BKWBearDemo:SetBackdropColor(1,1,1)
					BKWBearDemoText:SetText(j)
				end
			end
		elseif j==0 and InCombatLockdown() then
			if i==BADKITTY_MANGLE_CAT or i==BADKITTY_MANGLE_BEAR or i==BADKITTY_TRAUMA then
				if max(timeleft[BADKITTY_MANGLE_CAT],timeleft[BADKITTY_MANGLE_BEAR],timeleft[BADKITTY_TRAUMA])>0 then 
				else
					BKWBearMangle:Show()
					BKWBearMangle:SetBackdropColor(1,0,0)
					BKWBearMangleText:SetText(j)
				end
			elseif i==BADKITTY_LACERATE then 
				BKWBearLacerate:Show()
				BKWBearLacerate:SetBackdropColor(1,0,0)
				BKWBearLacerateText:SetText(j)
			elseif i==BADKITTY_FAERIE_FIRE_FERAL or i==BADKITTY_FAERIE_FIRE then 
				if max(timeleft[BADKITTY_FAERIE_FIRE_FERAL],timeleft[BADKITTY_FAERIE_FIRE])>0 then 
				else
					BKWBearFFF:Show()
					BKWBearFFF:SetBackdropColor(1,0,0)
					BKWBearFFFText:SetText(j)
				end
			elseif i==BADKITTY_DEMO_SHOUT or i==BADKITTY_DEMO_ROAR then 
				if max(timeleft[BADKITTY_DEMO_SHOUT],timeleft[BADKITTY_DEMO_ROAR])>0 then 
				else
					BKWBearDemo:Show()
					BKWBearDemo:SetBackdropColor(1,0,0)
					BKWBearDemoText:SetText(j)
				end
			end
		elseif j>BadKittySaves[12] and InCombatLockdown() then
			if i==BADKITTY_MANGLE_CAT or i==BADKITTY_MANGLE_BEAR or i==BADKITTY_TRAUMA then BKWBearMangle:Hide()
			elseif i==BADKITTY_LACERATE then BKWBearLacerate:Hide()
			elseif i==BADKITTY_DEMO_ROAR or i==BADKITTY_DEMO_SHOUT then BKWBearDemo:Hide()
			elseif i==BADKITTY_FAERIE_FIRE_FERAL or i==BADKITTY_FAERIE_FIRE then BKWBearFFF:Hide()
			end
		end
	end
end

function BadKitty_TFZerk(timenow)
	if BadKittySaves[11]==0 or not InCombatLockdown() then
		BKWTF:Hide()
		BKWZerk:Hide()
		BKWBearZerk:Hide()
		BKWBearBarkskin:Hide()
		return 0
	end
	local TFstart,TFcd,TFenable = GetSpellCooldown(BADKITTY_TIGERS_FURY)
	local Zstart,Zcd,Zenable = GetSpellCooldown(BADKITTY_BERSERK)
	local Bstart,Bcd,Benable = GetSpellCooldown(BADKITTY_BARKSKIN)
	local TFleft = floor(10*(TFstart+TFcd-timenow))/10
	local Zleft = floor(10*(Zstart+Zcd-timenow))/10
	local Bleft = floor(10*(Bstart+Bcd-timenow))/10
	if GetSpellCooldown(BADKITTY_MANGLE_CAT) then
		if Zleft<1.5 then	--this is put in place to prevent the GCD from appearing on the warnings frame.
			Zleft=0
		end
		if Bleft<1.5 then	
			Bleft=0
		end
		if TFleft<1.5 then	
			TFleft=0
		end
	end
	if TFleft < 0 then TFleft = 0 end
	if Zleft < 0 then Zleft = 0 end
	if Bleft < 0 then Bleft = 0 end
	if GetShapeshiftForm(true)==3 then
		if TFleft<3 and TFstart~=0 and InCombatLockdown() then
			BKWTF:Show()
			BKWTFText:SetText(TFleft)
		elseif TFleft==0 and InCombatLockdown() then
			BKWTF:Show()
			BKWTF:SetBackdropColor(1,0,0)
			BKWTFText:SetText(TFleft)
		elseif TFleft>3 or TFstart==0 or not InCombatLockdown() then
			BKWTF:Hide()
		end
	else
		BKWTF:Hide()
		BKWZerk:Hide()
	end
	if Zleft<3 and Zstart~=0 and InCombatLockdown() then
		if GetShapeshiftForm(true)==3 then
			BKWZerk:Show()
			BKWZerkText:SetText(Zleft)
			BKWBearZerk:Hide()
		elseif GetShapeshiftForm(true)==1 then
			BKWBearZerk:Show()
			BKWBearZerkText:SetText(Zleft)
			BKWZerk:Hide()
		end
	elseif Zleft<=0 and InCombatLockdown() then
		if GetShapeshiftForm(true)==3 then
			BKWZerk:Show()
			BKWZerk:SetBackdropColor(1,0,0)
			BKWZerkText:SetText(Zleft)
			BKWBearZerk:Hide()
		elseif GetShapeshiftForm(true)==1 then
			BKWBearZerk:Show()
			BKWBearZerk:SetBackdropColor(1,0,0)
			BKWBearZerkText:SetText(Zleft)
			BKWZerk:Hide()
		end
	elseif Zleft>3 or Zstart==0 or not InCombatLockdown() then
		BKWZerk:Hide()
		BKWBearZerk:Hide()
	end
	if GetShapeshiftForm(true)==1 then
		if Bleft<3 and Bstart~=0 and InCombatLockdown() then
			BKWBearBarkskin:Show()
			BKWBearBarkskinText:SetText(Bleft)
		elseif Bleft==0 and InCombatLockdown() then
			BKWBearBarkskin:Show()
			BKWBearBarkskin:SetBackdropColor(1,0,0)
			BKWBearBarkskinText:SetText(Bleft)
		elseif Bleft>3 or Bstart==0 or not InCombatLockdown() then
			BKWBearBarkskin:Hide()
		end
	end
end

function BadKitty_Setup()
	local _G = getfenv()
	BadKittyFrame:SetHeight(BadKittySaves[1]*BadKittyCatCount)
	BadKittyBear:SetHeight(BadKittySaves[3]*BadKittyBearCount)
	BadKittyFrame:SetWidth(BadKittySaves[2])
	BadKittyBear:SetWidth(BadKittySaves[2])
	for i=1,BadKittyCatCount,1 do
		_G["BadKittyFrameBar"..i]:SetWidth(BadKittySaves[2])
		_G["BadKittyFrameBar"..i]:SetHeight(BadKittySaves[1])
		--_G["BadKittyFrameBar"..i]:SetPoint("TOP",BadKittyFrame, "TOP",0,BadKittySaves[1]*(i-1))
	end
	for i=1,BadKittyBearCount,1 do
		_G["BadKittyBearBar"..i]:SetWidth(BadKittySaves[2])
		_G["BadKittyBearBar"..i]:SetHeight(BadKittySaves[1])
		--_G["BadKittyBearBar"..i]:SetPoint("TOP",BadKittyBear, "TOP",0,BadKittySaves[1]*(i-1))
	end
	BKOOCFrame:SetWidth(min(BadKittySaves[1]*BadKittyCatCount,BadKittySaves[2]))
	BKOOCFrame:SetHeight(min(BadKittySaves[1]*BadKittyCatCount,BadKittySaves[2]))
	BKBearOOCFrame:SetWidth(min(BadKittySaves[1]*BadKittyBearCount,BadKittySaves[2]))
	BKBearOOCFrame:SetHeight(min(BadKittySaves[1]*BadKittyBearCount,BadKittySaves[2]))
	
	BadKittyCatSRText:SetText("Savage Roar")
	BadKittyCatMangleText:SetText("Mangle")
	BadKittyCatRipText:SetText("Rip")
	BadKittyCatRakeText:SetText("Rake")
	BadKittyCatFFFText:SetText("FFF")
	BadKittyCatCPText:SetText("Combo")
	

	--Bar Text Stuff
	--[[BadKittyFrameSRBarText:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyFrameMangleBarText:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyFrameRakeBarText:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyFrameRipBarText:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyFrameFFFBarText:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyFrameCPBarText:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyBearDemoBarText:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyBearLacBarText:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyBearMangleBarText:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyBearFFFBarText:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyFrameSRBarText:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyFrameMangleBarSecs:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyFrameRakeBarSecs:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyFrameRipBarSecs:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyFrameFFFBarSecs:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyFrameCPBarSecs:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyBearDemoBarSecs:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyBearLacBarSecs:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyBearMangleBarSecs:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	BadKittyBearFFFBarSecs:SetFont("Fonts\FRIZQT__.TTF",BadKittySaves[6])
	--Warning Frame text (placeholder kinda)
	BKWMangleText:SetFont("Fonts\\FRIZQT__.TTF", 30)
	BKWSRText:SetFont("Fonts\\FRIZQT__.TTF", 30)
	BKWRakeText:SetFont("Fonts\\FRIZQT__.TTF", 30)
	BKWRipText:SetFont("Fonts\\FRIZQT__.TTF", 30)
	BKWFFFText:SetFont("Fonts\\FRIZQT__.TTF", 30)
	BKWTFText:SetFont("Fonts\\FRIZQT__.TTF", 30)
	BKWZerkText:SetFont("Fonts\\FRIZQT__.TTF", 30)
	BKWBearMangleText:SetFont("Fonts\\FRIZQT__.TTF", 30)
	BKWBearLacerateText:SetFont("Fonts\\FRIZQT__.TTF", 30)
	BKWBearZerkText:SetFont("Fonts\\FRIZQT__.TTF", 30)
	BKWBearDemoText:SetFont("Fonts\\FRIZQT__.TTF", 30)
	BKWBearFFFText:SetFont("Fonts\\FRIZQT__.TTF", 30)
	BKWBearBarkskinText:SetFont("Fonts\\FRIZQT__.TTF", 30)]]
end

